#ifndef I0mapmon_topo_H
#define I0mapmon_topo_H

#include <QWidget>

#include <qulogimpl.h>
#include <cucontrolsfactorypool.h>

class CumbiaPool;
class QuMultiReaderPluginInterface;
class CheckableComboBoxModel;
class CuData;

namespace Ui {
class I0mapmon_topo;
}

class I0mapmon_topo : public QWidget
{
    Q_OBJECT

public:
    explicit I0mapmon_topo(CumbiaPool *cu_p, QWidget *parent = 0);
    ~I0mapmon_topo();

private:
    Ui::I0mapmon_topo *ui;

    // cumbia
    CumbiaPool *cu_pool;
    QuLogImpl m_log_impl;
    CuControlsFactoryPool m_ctrl_factory_pool;
    // cumbia

    QuMultiReaderPluginInterface *m_multiread_plu_i;

    QString m_dev;
    QStringList m_names;
    CheckableComboBoxModel *m_cb_model;

private slots:
    void m_onNamesReady(const QStringList &names);
    void m_onHwPosReady(const QStringList &names);
    void m_onLabelsReady(const QStringList &names);
    void m_onWlenSelectionChanged(QString wlen, bool on);
    void m_onLambdaChanged(const QVector<double>& la);
    void m_txf(bool txf);
    void m_onStateChanged(const CuData &da);
};

#endif // I0mapmon_topo_H
